Responsive grid system for React

Updated on May 17, 2021

Flexible 12 column grid system for building responsive layouts with flexbox

Mobile first responsive layout built with flexbox. Working with 12 columns across five breakpoints to cover a great variety of screen sizes.

Sizes cover extra small - up to 576 px, small, medium, large and extra large screens - above 1200 px.

Use it to create flexible layouts with the following features:

  • Five built-in breakpoints
  • Optional fixed width grids
  • 12 column grid across all screen sizes for fine grain control
  • Vertical and horizontal alignment of columns inside the grid
  • Column offsets for precise positioning
  • Push and pull for reordering content responsively
  • Equal width columns and dynamic width columns
  • Future proof built with flexbox


Grid layout demos available for other frameworks.

Viewing demos & code for

React Grid layout Grid layout for React

Grid layout - Column sizing

Change demo
Column sizing
React Grid system with multiple ways to layout content. Equal width, specific width, dynamic and self adjusting columns. For React and Next.JS.
Copy code

Grid layout - Vertical alignment

Change demo
Vertical alignment
React Grid system with multiple ways to vertically align content. Layout at the start, center or the end of the grid. For React and Next.JS.
Copy code

Grid layout - Horizontal alignment

Change demo
Horizontal alignment
React Grid system with multiple ways to horizontally align content. Push to start, middle, end or justify around/in-between. For React and Next.JS.
Copy code

Grid layout - Offsetting columns

Change demo
Offsetting columns
React Grid layout example for pushing content with column offsets. Adjust the left margin with as much as needed. For React and Next.JS.
Copy code
import mobiscroll from '@mobiscroll/react';
import '@mobiscroll/react/dist/css/mobiscroll.min.css';

class App extends React.Component {
    render () {
        return (
            <mobiscroll.Form className="md-grid-offset">
                <mobiscroll.FormGroup>
                    <mobiscroll.FormGroupTitle>Offsetting columns</mobiscroll.FormGroupTitle>
                    <div className="mbsc-grid">
                        <div className="mbsc-row">
                            <div className="mbsc-col-4">1 of 2</div>
                            <div className="mbsc-col-4 mbsc-offset-4">2 of 2</div>
                        </div>
                        <div className="mbsc-row">
                            <div className="mbsc-col-3  mbsc-offset-3">1 of 2</div>
                            <div className="mbsc-col-3  mbsc-offset-3">2 of 2</div>
                        </div>
                        <div className="mbsc-row">
                            <div className="mbsc-col-6  mbsc-offset-3">1 of 1</div>
                        </div>
                    </div>
                </mobiscroll.FormGroup>
            </mobiscroll.Form>
        );
    }    
}

<div id="content"></div>
.md-grid-offset [class*="mbsc-col"] {
    padding-top: .5em;
    padding-bottom: .5em;
    background: #cfe0f3;
    background-clip: padding-box;
    border: 1px solid transparent;
    color: #454b50;
}

.md-grid-offset .mbsc-row {
    margin: 1em 0;
    padding: 1px;
    background: rgba(188, 141, 224, 0.58);
}

Grid layout - Push and pull

Change demo
Push and pull
React Grid system with responsive re-arranging content using push and pull features. Specify behavior on breakpoints. For React and Next.JS.
Viewport
Copy code

Grid layout - Responsive

Change demo
Responsive
React Responsive grid system showing off different methods for laying out content based on breakpoints or without it. For React and Next.JS.
Viewport
Copy code

Grid layout - Fixed width

Change demo
Fixed width
React Grid layout demo with fixed width container. Depending on the screen-size, the responsive container gets a fixed width. For React and Next.JS.
Viewport
Copy code

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Customize & try demos locally
Sign in or start your free trial

What framework are you using?

Javascript
jQuery
AngularJS
Angular
React
Other
Ionic Angular
Email address

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Create an Ionic 3 & Mobiscroll starter with the CLI:

$ mobiscroll start ionic myStarter

Run this command for Ionic 4 & Mobiscroll starter:

$ mobiscroll start ionic-angular myStarter

Step 3.Copy the code into your app.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Run this command for Ionic 5 & React Mobiscroll starter:

$ mobiscroll start react-ionic myStarter

Step 3.Copy the code into your app.

Copy TSX
Copy CSS

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Customize & try demos locally
How would you like to do it?
Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Angular project

Copy command
$ mobiscroll config angular --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Step 3.Copy the code into your app. HTML goes into the markup, TS into Typescript.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ng serve in the root folder of your app 🎉

Copy command
$ ng serve

And voilà, everything should be running smoothly.

Thanks for downloading
Try and customize the app locally

Extract the zip file and run the project like any Ionic app. Make sure to have Ionic CLI installed and open the terminal in the app root folder.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ionic serve

Let us know if we can help and enjoy!

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

Extract the zip file and open the demo in your favorite browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Please extract the zip file and run the project like any Angular CLI app. Make sure to have the Angular CLI installed.

For installation and usage, extract the zip file and open a terminal window and follow these steps.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ng serve --open

Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The easiest way to get started is to follow the installation steps and by grabbing the code directly from the demo page. Let us know if we can help and enjoy! 👍

You'll find a fully functional Kitchen-sink Ionic app in the zip file.

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The demos are using Babel's in-browser ES6 and JSX transformer.
Extract the zip file and open the demo in your browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Email address

Need to update your password?
Demos
Theme Select
Mobiscroll
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos

Responsive grid system for Angular

Updated on May 17, 2021

Flexible 12 column grid system for building responsive layouts with flexbox

Mobile first responsive layout built with flexbox. Working with 12 columns across five breakpoints to cover a great variety of screen sizes.

Sizes cover extra small - up to 576 px, small, medium, large and extra large screens - above 1200 px.

Use it to create flexible layouts with the following features:

  • Five built-in breakpoints
  • Optional fixed width grids
  • 12 column grid across all screen sizes for fine grain control
  • Vertical and horizontal alignment of columns inside the grid
  • Column offsets for precise positioning
  • Push and pull for reordering content responsively
  • Equal width columns and dynamic width columns
  • Future proof built with flexbox


Grid layout demos available for other frameworks.

Viewing demos & code for

Angular and Ionic Grid layout Grid layout for Angular and Ionic Framework

Grid layout - Column sizing

Change demo
Column sizing
Angular Grid system with multiple ways to layout content. Equal width, specific width, dynamic and self adjusting columns. For Angular 22 and Ionic 8.
Copy code

Grid layout - Vertical alignment

Change demo
Vertical alignment
Angular Grid system with multiple ways to vertically align content. Layout at the start, center or the end of the grid. For Angular 22 and Ionic 8.
Copy code

Grid layout - Horizontal alignment

Change demo
Horizontal alignment
Angular Grid system with multiple ways to horizontally align content. Push to start, middle, end or justify around/in-between. For Angular 22 and Ionic 8.
Copy code

Grid layout - Offsetting columns

Change demo
Offsetting columns
Angular Grid layout example for pushing content with column offsets. Adjust the left margin with as much as needed. For Angular 22 and Ionic 8.
Copy code
import { Component } from '@angular/core';

@Component({
    selector: 'app-root',
    templateUrl: './app.component.html'
})
export class AppComponent {}
<mbsc-form class="md-grid-offset">
    <mbsc-form-group>
        <mbsc-form-group-title>Offsetting columns</mbsc-form-group-title>
        <div class="mbsc-grid">
            <div class="mbsc-row">
                <div class="mbsc-col-4">1 of 2</div>
                <div class="mbsc-col-4 mbsc-offset-4">2 of 2</div>
            </div>
            <div class="mbsc-row">
                <div class="mbsc-col-3  mbsc-offset-3">1 of 2</div>
                <div class="mbsc-col-3  mbsc-offset-3">2 of 2</div>
            </div>
            <div class="mbsc-row">
                <div class="mbsc-col-6  mbsc-offset-3">1 of 1</div>
            </div>
        </div>
    </mbsc-form-group>
</mbsc-form>
.md-grid-offset [class*="mbsc-col"] {
    padding-top: .5em;
    padding-bottom: .5em;
    background: #cfe0f3;
    background-clip: padding-box;
    border: 1px solid transparent;
    color: #454b50;
}

.md-grid-offset .mbsc-row {
    margin: 1em 0;
    padding: 1px;
    background: rgba(188, 141, 224, 0.58);
}
import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { HttpClientModule, HttpClientJsonpModule } from '@angular/common/http';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { MbscModule } from '@mobiscroll/angular';
import { AppComponent } from './app.component';

@NgModule({
  declarations: [
    AppComponent
  ],
  imports: [
    BrowserModule,
    MbscModule,
    FormsModule,
    ReactiveFormsModule,
    HttpClientModule,
    HttpClientJsonpModule
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }

Grid layout - Push and pull

Change demo
Push and pull
Angular Grid system with responsive re-arranging content using push and pull features. Specify behavior on breakpoints. For Angular 22 and Ionic 8.
Viewport
Copy code

Grid layout - Responsive

Change demo
Responsive
Angular Responsive grid system showing off different methods for laying out content based on breakpoints or without it. For Angular 22 and Ionic 8.
Viewport
Copy code

Grid layout - Fixed width

Change demo
Fixed width
Angular Grid layout demo with fixed width container. Depending on the screen-size, the responsive container gets a fixed width. For Angular 22 and Ionic 8.
Viewport
Copy code

Looking for something you didn't see or have a sales question?
Ask us about it, we're here to help.

Customize & try demos locally
Sign in or start your free trial

What framework are you using?

Javascript
jQuery
AngularJS
Angular
React
Other
Ionic Angular
Email address

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Create an Ionic 3 & Mobiscroll starter with the CLI:

$ mobiscroll start ionic myStarter

Run this command for Ionic 4 & Mobiscroll starter:

$ mobiscroll start ionic-angular myStarter

Step 3.Copy the code into your app.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Ionic project

Copy command
$ mobiscroll config ionic --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Run this command for Ionic 5 & React Mobiscroll starter:

$ mobiscroll start react-ionic myStarter

Step 3.Copy the code into your app.

Copy TSX
Copy CSS

Step 4.Run ionic serve in the root folder of your app 🎉

Copy command
$ ionic serve

And voilà, everything should be running smoothly.

Customize & try demos locally
How would you like to do it?
Install demo in your app
Follow this quick, two minute install guide
Close window

Step 1.Install the Mobiscroll CLI from npm

Copy command
$ npm install -g @mobiscroll/cli

The CLI makes configuring your apps super simple 👍

Step 2.Run the following command in the root folder of your Angular project

Copy command
$ mobiscroll config angular --version=4

You will be prompted to log in with your mobiscroll account. Set your password here

Step 3.Copy the code into your app. HTML goes into the markup, TS into Typescript.

Copy TS
Copy HTML
Copy CSS
Copy Module

Step 4.Run ng serve in the root folder of your app 🎉

Copy command
$ ng serve

And voilà, everything should be running smoothly.

Thanks for downloading
Try and customize the app locally

Extract the zip file and run the project like any Ionic app. Make sure to have Ionic CLI installed and open the terminal in the app root folder.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ionic serve

Let us know if we can help and enjoy!

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

Extract the zip file and open the demo in your favorite browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Please extract the zip file and run the project like any Angular CLI app. Make sure to have the Angular CLI installed.

For installation and usage, extract the zip file and open a terminal window and follow these steps.

Step 1. Run in root folder
$ npm install
Step 2. Start the app
$ ng serve --open

Let us know if we can help and enjoy! 👍

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The easiest way to get started is to follow the installation steps and by grabbing the code directly from the demo page. Let us know if we can help and enjoy! 👍

You'll find a fully functional Kitchen-sink Ionic app in the zip file.

Thanks for downloading
Customize demos locally

Everything is set up so that you can dig in right away and start exploring.

We have set up a trial so that you can try the demos locally.

The demos are using Babel's in-browser ES6 and JSX transformer.
Extract the zip file and open the demo in your browser. To install Mobiscroll in your project follow instructions from this page.


Let us know if we can help and enjoy! 👍

Customize & try this demo locally
Sign in or start your free trial

We have to set you up with a trial for this to run 👍

Email address

Need to update your password?
Demos
Theme Select
Mobiscroll
Material
Material Dark
iOS
iOS Dark
Windows
Windows Dark
Language Locale
See other demos and change options
Theme
Locale
See other demos